#!/usr/bin/ruby
# .
# start_watobo.rb
#   
# Copyright 2010 by siberas, http://www.siberas.de
# 
# This file is part of WATOBO (Web Application Tool Box)
#        http://watobo.sourceforge.com
# 
# WATOBO is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2 of the License.
# 
# WATOBO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with WATOBO; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# .
if __FILE__ == $0
  
  #Thread.abort_on_exception = true
  require 'rubygems'
  begin
    require 'fox16'
  rescue LoadError
    puts "!!! Seems like FXRuby is not installed !!!"
    puts "please check the installation tutorial at http://watobo.sourceforge.net"
    exit
  end
  require 'lib/qGui'
  require 'lib/core/watobo_constants'
  require 'lib/utils/load_icon'
  require 'lib/gui/about_watobo'
  
  include Fox
  include Watobo::Utils
  include Watobo::Gui
  
  $version = "0.9.6rev266"
  $watobo_base = File.expand_path(File.dirname(__FILE__))
  
  def loadWatoboIcon(application, filename)
    file = File.join($watobo_base, Watobo::Core::ICON_PATH, filename)
    loadIcon(application, file)
  end
  
  application = FXApp.new("Watobo", "The Webapplication Toolbox")
  #application.init(ARGV)
  
  # ICON_SPLASH = loadWatoboIcon(application, "watobo-logo.gif")
  WATOBO_LOGO = loadIcon(application, File.join($watobo_base, "watobo-logo.png"))
  
  ICON_CB_UNCHECKED = loadWatoboIcon(application, "cb_unchecked.ico") 
  ICON_CB_CHECKED = loadWatoboIcon(application, "cb_checked.ico")
  ICON_CB_CHECKED_ORANGE = loadWatoboIcon(application, "cb_checked_orange.ico")
  
  ICON_WATOBO = loadWatoboIcon(application, "watobo.ico")
  
  ICON_FUZZ_TAG = loadWatoboIcon(application, "tag_blue_32x32.ico")
  ICON_FUZZ_FILTER = loadWatoboIcon(application, "filter.ico")
  ICON_FUZZ_GENERATOR = loadWatoboIcon(application, "engine.ico")
  
  ICON_MANUAL_REQUEST = loadWatoboIcon(application, "applications_24x24.ico")
  ICON_MANUAL_REQUEST_MEDIUM = loadWatoboIcon(application, "applications_24x24.ico")
  ICON_MANUAL_REQUEST_SMALL = loadWatoboIcon(application, "applications_16x16.ico")
  ICON_LOGIN_WIZZARD =  loadWatoboIcon(application, "User.ico")
  ICON_DIFFER =  loadWatoboIcon(application, "monitor.ico")
  
  ICON_START = loadWatoboIcon(application, "Play_24x24.ico")
  ICON_STOP = loadWatoboIcon(application, "Stop_24x24.ico")
  ICON_PAUSE = loadWatoboIcon(application, "Pause.ico")
  ICON_REPORT = loadWatoboIcon(application, "Write Document.ico")
  ICON_ADD_PROJECT = loadWatoboIcon(application, "Add_24x24.ico")
  ICON_DASHBOARD = loadWatoboIcon(application, "Bandwidth_24x24.ico")
  ICON_CONVERSATION = loadWatoboIcon(application, "conversation_24x24.ico")
  ICON_TRANSCODER = loadWatoboIcon(application, "calculator_24x24.ico")
  ICON_PROJECT = loadWatoboIcon(application, "browser_24x24.ico")
  ICON_FUZZER = loadWatoboIcon(application, "fuzzer_24x24.ico")
  ICON_FUZZER_MEDIUM = loadWatoboIcon(application, "fuzzer_24x24.ico")
  ICON_FUZZER_SMALL = loadWatoboIcon(application, "fuzzer_16x16.ico")
  ICON_PLUGIN = loadWatoboIcon(application, "plugin_24x24.ico")
  
  # Findings Tree Icons
  ICON_VULN = loadWatoboIcon(application, "Mr. Bomb_24x24.ico")
  ICON_VULN_LOW = loadWatoboIcon(application, "Yellow Ball_24x24.ico")
  ICON_VULN_MEDIUM = loadWatoboIcon(application, "Orange Ball_24x24.ico")
  ICON_VULN_HIGH = loadWatoboIcon(application, "Red Ball_24x24.ico")
  ICON_VULN_CRITICAL = loadWatoboIcon(application, "burn_24x24.ico")
  ICON_INFO = loadWatoboIcon(application, "info_24x24.ico")
  ICON_INFO_INFO = loadWatoboIcon(application, "iChat_24x24.ico")
  ICON_INFO_USER = loadWatoboIcon(application, "User_24x24.ico")
  ICON_HINTS = loadWatoboIcon(application, "advanced_24x24.ico")  
   ICON_HINTS_INFO = loadWatoboIcon(application, "help_24x24.ico")
   
  # small
  ICON_PROJECT_SMALL = loadWatoboIcon(application, "Web Browser_16x16.ico")
  ICON_VULN_SMALL = loadWatoboIcon(application, "Mr. Bomb_16x16.ico")
    ICON_VULN_LOW_SMALL = loadWatoboIcon(application, "Yellow Ball_16x16.ico")
    ICON_VULN_MEDIUM_SMALL = loadWatoboIcon(application, "Orange Ball_16x16.ico")
    ICON_VULN_HIGH_SMALL = loadWatoboIcon(application, "Red Ball_16x16.ico")
    ICON_VULN_CRITICAL_SMALL = loadWatoboIcon(application, "burn_16x16.ico")
    ICON_INFO_SMALL = loadWatoboIcon(application, "info_16x16.ico")
    ICON_INFO_INFO_SMALL = loadWatoboIcon(application, "iChat_16x16.ico")
    ICON_INFO_USER_SMALL = loadWatoboIcon(application, "User_16x16.ico")
  ICON_HINTS_SMALL = loadWatoboIcon(application, "advanced_16x16.ico")  
   ICON_HINTS_INFO_SMALL = loadWatoboIcon(application, "help_16x16.ico")
    
  # Sites Tree Icons
  ICON_FOLDER = loadWatoboIcon(application, "folder.ico")
  ICON_REQUEST = loadWatoboIcon(application, "Transfer.ico")
  ICON_SITE = loadWatoboIcon(application, "server.ico")
  
  ICON_FOLDER_SMALL = loadWatoboIcon(application, "folder_16x16.ico")
   ICON_REQUEST_SMALL = loadWatoboIcon(application, "Transfer_16x16.ico")
   ICON_SITE_SMALL = loadWatoboIcon(application, "server_16x16.ico")
  
  
 
  
  ICON_SEND_REQUEST = loadWatoboIcon(application, "send.ico")
  ICON_BROWSER_SMALL = loadWatoboIcon(application, "browser_16x16.ico")
  ICON_BROWSER_MEDIUM = loadWatoboIcon(application, "browser_24x24.ico")
  
  ICON_BTN_UP = loadWatoboIcon(application, "go-up_16x16.png")
  ICON_BTN_DOWN = loadWatoboIcon(application, "go-down_16x16.png")
  
  SIBERAS_ICON = FXGIFIcon.new(application, File.open(File.join(File.expand_path(File.dirname(__FILE__)), "siberas_logo_x24.gif"), "rb").read)
#red_transp.transparentColor = FXRGB(255, 255, 255)

  
  #settings = Hash.new
  #settings[:base_dir] = File.expand_path(File.dirname(__FILE__))
  
  puts "#############################################################"
  puts
  puts "     W A T O B O - Web Application Toolbox  (#{$version})"
  puts "     brought to you by siberas http://www.siberas.de"
  puts
  puts "#############################################################"
 # puts "Base Directory: #{settings[:base_dir]}"
  #puts settings[:base_dir]
 # puts $0
  
  interface = WatoboMainWindow.new(application)
  FXToolTip.new(application)
  application.create   
  
  file = File.join(File.expand_path(File.dirname(__FILE__)), Watobo::Core::FIRST_TIME_FILE)
  unless File.exists?(file)
    first_start_info = Watobo::Gui::AboutWatobo.new(interface)
    if first_start_info.execute != 0 then
      File.new(file, "w")
    else
      exit
    end
  end
  
  application.run
  
end

# NOTES
#TODO: Checkout -> self.accelTable.addAccel(fxparseAccel("Ctl-Q"), getApp(), FXSEL(SEL_COMMAND, FXApp::ID_QUIT))